( Code by olus2000 )


create char-buf 1 chars allot


: next-char? ( -- ? )
  char-buf 1 stdin read-file drop ;

: get-char ( -- c )
  char-buf 1 stdin read-file 2drop
  char-buf c@ ;


1 value dict-size
0 value dict


: d@ ( addr -- n )
  0 swap dict-size 0 +do
    dup i + c@ i 8 * lshift rot + swap
  loop drop ;


: d! ( n addr -- )
  dup dict-size + swap +do
    256 /mod swap i c!
  loop drop ;


: d-emit ( n -- )
  dict-size 0 +do
    256 /mod swap emit
  loop drop ;


: d-read ( -- n )
  0 dict-size 0 +do
    next-char? drop char-buf c@ i 8 * lshift +
  loop ;


: d, ( n -- )
  dict-size 0 +do
    256 /mod swap c,
  loop drop ;


( Decoding )


: decoder-cell ( -- size ) dict-size 1+ chars ;

: decoder-entry>addr ( entry -- addr ) decoder-cell * dict + ;

: parent ( entry -- addr ) decoder-entry>addr ;

: decoder-char ( entry -- addr ) decoder-entry>addr dict-size chars + ;


: reset-d-dict ( -- )
  dict here - decoder-cell + allot
  0 0 parent d!
  0 0 decoder-char c! ;


: d-dict-size ( -- n )
  here dict - decoder-cell / ;


: emit-char ( entry -- )
  char-buf c@ emit
  d-dict-size decoder-cell allot
  char-buf c@ over decoder-char c!
  parent d! ;


: traverse-decoder ( -- entry )
  here d-read tuck begin dup while
    dup decoder-char c@ c,
    parent d@
  repeat drop
  here over 1- over 1- -do
    i c@ emit
  1 -loop - allot ;


: decode-lz ( -- )
  get-char to dict-size
  here to dict reset-d-dict
  0 begin next-char? while
    emit-char traverse-decoder
    d-dict-size 1 dict-size 8 * lshift >=
    if reset-d-dict drop 0 then
  repeat drop ;


( Encoding )


: encoder-cell ( -- size ) dict-size 2* 1+ chars ;

: encoder-entry>addr ( entry -- addr ) encoder-cell * dict + ;

: sibling ( entry -- addr ) encoder-entry>addr ;

: child ( entry -- addr ) encoder-entry>addr dict-size chars + ;

: encoder-char ( entry -- addr ) encoder-entry>addr dict-size 2* chars + ;


: reset-e-dict ( -- )
  dict here - encoder-cell + allot
  0 0 sibling d!
  0 0 child d!
  0 0 encoder-char c! ;


: e-dict-size ( -- n )
  here dict - encoder-cell / ;


: append-char ( entry -- )
  char-buf c@ emit
  e-dict-size encoder-cell allot
  over child d@ over sibling d!
  0 over child d!
  char-buf c@ over encoder-char c!
  swap child d! ;


: next-entry? ( entry -- entry ? )
  dup child d@
  begin dup while
    dup encoder-char c@
    char-buf c@ <> while
    sibling d@
  repeat nip true else drop false then ;


: traverse-encoder ( -- entry ? )
  0 begin
    next-char? while
    next-entry? 0=
  until true else false then 
  over d-emit ;


: encode-lz ( n -- )
  dup to dict-size emit next-char? if
    here to dict reset-e-dict
    0 begin
      append-char traverse-encoder
      e-dict-size 1 dict-size 8 * lshift >=
      if reset-e-dict nip 0 swap then
    0= until drop
  then ;


: help ( -- )
  ." Usage: gforth entry.fs (-h | -d | -e n)" cr
  cr
  ." Options:" cr
  cr
  ."         -h" cr
  ."                 Print this help." cr
  cr
  ."         -d" cr
  ."                 Decode the stream passed from standard input." cr
  ."                 Dictionary size is encoded in the data." cr
  cr
  ."         -e n" cr
  ."                 Encode the stream passed from standard input." cr
  ."                 n denotes dictionary address size in bytes." cr ;


: entry ( -- )
  argc @ 1 <= if ." Not enough arguments." cr cr help else
    next-arg case
      2dup s" -d" str= true of 2drop decode-lz endof drop
      2dup s" -h" str= true of 2drop help      endof drop
      2dup s" -e" str= true of 2drop
        next-arg dup 0= if
          2drop ." Encoding requires dictionary size." cr cr help
        else
          s>unumber? if
            drop encode-lz
          else
            2drop ." Encoding requires dictionary size." cr cr help
          then
        then
      endof drop ." Invalid option: " type cr cr help 0 endcase
  then ;


entry bye
